package appl.parallel;


/**
 * Encapsulates {@link ComputingResource ComputingResources} and their meta
 * Information (for fast access)
 *
 * @author Dominik Appl
 */
public class ComputingResourceContainer {

	private final ComputingResource resource;

	private final ComputingResourceProperties information;

	private boolean supportsSimpleRemoteExecution = false;

	/**
	 * @param resource
	 * @param information
	 */
	public ComputingResourceContainer(ComputingResource resource,
			ComputingResourceProperties information) {
		this.resource = resource;
		this.information = information;
	}

	/**
	 * @return the information
	 */
	public ComputingResourceProperties getInformation() {
		return information;
	}

	/**
	 * @return the resource
	 */
	public ComputingResource getResource() {
		return resource;
	}

	public String toString() {
		if (information != null)
			return information.getProperty("Name");
		else
			return "Unknown Resource(No Information available)";
	}

	public boolean supportsSimpleRemoteExecution() {
		return supportsSimpleRemoteExecution;
	}

}
