package appl.parallel.client;

import java.util.Vector;

import appl.parallel.ComputingResourceContainer;

/**
 * Listeners which implement this interface can react on changes on the availability of
 * remote resources. GUI classes use the interface to keep their resource list up to date.
 *  
 * @see RemoteExecutionController for a handler
 * 
 * @author Dominik Appl
 */
public interface ResourceChangeListener {
	
	/**
	 * @param currentResources the current active remote resources
	 */
	public void updateResources(Vector<ComputingResourceContainer> currentResources);  

}
