package appl.parallel.data.splittable;

import edu.bonn.xulu.plugin.io.grid.WritableGridFactory;
// nur fuer Doku
import schmitzm.data.WritableGrid;
import edu.bonn.xulu.plugin.data.grid.MultiGrid;

/**
 * Diese Factory erzeugt Standard-Instanzen von {@link MultiGrid} mit
 * durch die Factory {@link SplittableGridLLFactory} erzeugten (auf Standard-Arrays
 * basierenden) {@link WritableGrid}-Instanzen als Inhalt.
 * @author Dominik Appl
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of Bonn/Germany)
 * @version 1.0
 */
public class MultiGridFactory extends edu.bonn.xulu.plugin.io.grid.awt.MultiGridFactory {
  /**
   * Liefert eine Instanz von {@link SplittableGridLLFactory}, die auf Standard-Arrays
   * basierende Instanzen von {@link WritableGrid} erzeugt. Mit diesen
   * Instanzen wird die GridList gefuellt.
   */
  protected WritableGridFactory getWritableGridFactory() {
    return new SplittableGridLLFactory();
  }

}
