package appl.parallel.data.splittable;

import edu.bonn.xulu.io.InstantiationFactory;
// nur fuer Doku
import schmitzm.data.WritableGrid;
import edu.bonn.xulu.plugin.data.grid.SingleGrid;
import edu.bonn.xulu.plugin.io.grid.array.WritableGridArrayFactory;

/**
 * Diese Factory erzeugt Standard-Instanzen von {@link SingleGrid} mit einem
 * durch die Factory {@link SplittableGridLLFactory} erzeugten (auf Standard-Arrays basierenden)
 * {@link WritableGrid}.
 * @author Dominik Appl
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of Bonn/Germany)
 * @version 1.0
 */
public class SingleGridFactory  extends edu.bonn.xulu.plugin.io.grid.awt.SingleGridFactory{

  /**
   * Liefert eine Instanz von {@link WritableGridArrayFactory}, die auf Standard-Arrays
   * basierende Instanzen von {@link WritableGrid} erzeugt. Mit diesen
   * Instanzen wird das SingleGrid gefuellt.
   */
  protected InstantiationFactory getWritableGridFactory() {
    return new SplittableGridLLFactory();
  }
}
