package appl.parallel.event;

import java.rmi.Remote;
import java.rmi.RemoteException;

//doc
import appl.parallel.client.RemoteEventHandler;
import appl.parallel.services.RemoteEventProxy;


/**
 * A event sink for communication events receives {@link TimeEvent}s and {@link TransferEvent}s 
 * and processes them. 
 * 
 * @see RemoteEventHandler
 * @see RemoteEventProxy
 * @author Dominik Appl
 */
public interface CommEventSink extends Remote, RemoteEventSink {

	
	/**
	 * @return true if the service is running and time monitoring is enabled
	 */
	public boolean isTimeMonitoringEnabled() throws RemoteException;

	/**
	 * @return true if the service is running and transfer monitoring is enabled
	 */
	public boolean isTransferMonitoringEnabled() throws RemoteException;
	
}
