package appl.parallel.plugin.event;

import javax.swing.SwingUtilities;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JToggleButton;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import javax.swing.JCheckBox;
import javax.swing.BoxLayout;

import edu.bonn.xulu.gui.XuluInternalFrame;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.JTabbedPane;
import java.awt.Dimension;
import java.awt.Button;
import java.awt.CardLayout;
import javax.swing.JLabel;
import java.awt.Insets;
import javax.swing.JTextPane;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.DefaultStyledDocument;

/**
 * Provides a GUI for the {@link SimpleCommEventMonitorEngine}
 * 
 * @author Dominik Appl
 */
public class SimpleCommEventMonitor extends XuluInternalFrame {

	private static final long serialVersionUID = 1L;

	JPanel jContentPane = null;

	JScrollPane jScrollPane = null;

	JTable timeEventTable = null;

	JPanel optionsPanel = null;

	JCheckBox timeEventEnabled = null;

	JCheckBox transferEventEnabled = null;

	SimpleCommEventMonitorEngine engine;

	JTabbedPane jTabbedPane = null;

	Button clearButton = null;

	JScrollPane jScrollPane1 = null;

	JTable transferEventTable = null;

	private JTextPane jTextPane = null;

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getTimeEventTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes timeEventTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getTimeEventTable() {
		if (timeEventTable == null) {
			timeEventTable = new JTable();
			timeEventTable.setDoubleBuffered(true);
		}
		return timeEventTable;
	}

	/**
	 * This method initializes optionsPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getOptionsPanel() {
		if (optionsPanel == null) {
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.fill = GridBagConstraints.BOTH;
			gridBagConstraints8.gridy = 0;
			gridBagConstraints8.weightx = 1.0;
			gridBagConstraints8.weighty = 0.0;
			gridBagConstraints8.gridwidth = 1;
			gridBagConstraints8.gridheight = 1;
			gridBagConstraints8.anchor = GridBagConstraints.EAST;
			gridBagConstraints8.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints8.ipadx = 1;
			gridBagConstraints8.ipady = 0;
			gridBagConstraints8.gridx = 9;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints6.gridy = 0;
			gridBagConstraints6.anchor = GridBagConstraints.WEST;
			gridBagConstraints6.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints6.gridx = 8;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(5, 5, 5, 2);
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.anchor = GridBagConstraints.WEST;
			gridBagConstraints5.fill = GridBagConstraints.NONE;
			gridBagConstraints5.gridwidth = 1;
			gridBagConstraints5.gridx = 7;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.anchor = GridBagConstraints.WEST;
			gridBagConstraints4.gridwidth = 1;
			gridBagConstraints4.gridheight = 1;
			gridBagConstraints4.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			optionsPanel = new JPanel();
			optionsPanel.setLayout(new GridBagLayout());
			optionsPanel.add(getTimeEventEnabled(), gridBagConstraints4);
			optionsPanel.add(getTransferEventEnabled(), gridBagConstraints5);
			optionsPanel.add(getClearButton(), gridBagConstraints6);
			optionsPanel.add(getJTextPane(), gridBagConstraints8);
		}
		return optionsPanel;
	}

	/**
	 * This method initializes timeEventEnabled	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getTimeEventEnabled() {
		if (timeEventEnabled == null) {
			timeEventEnabled = new JCheckBox();
			timeEventEnabled.setText("log time events");
			timeEventEnabled.setName("timeEventEnabled");
			timeEventEnabled.addActionListener(engine);
		}
		return timeEventEnabled;
	}

	/**
	 * This method initializes transferEventEnabled	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getTransferEventEnabled() {
		if (transferEventEnabled == null) {
			transferEventEnabled = new JCheckBox();
			transferEventEnabled.setText("log transferEvents");
			transferEventEnabled.setName("transferEventEnabled");
			transferEventEnabled.addActionListener(engine);
		}
		return transferEventEnabled;
	}

	/**
	 * This is the default constructor
	 * @param engine the engine responsible for event handling
	 */
	public SimpleCommEventMonitor(SimpleCommEventMonitorEngine engine) {
		super("Simple Communication Event Monitor");
		this.setClosable(true);
		this.setDefaultCloseOperation(HIDE_ON_CLOSE);
		this.engine = engine;
		initialize();
	}

	/**
	 * This method initializes this class
	 * 
	 */
	private void initialize() {
		this.setSize(608, 326);
		this.setContentPane(getJContentPane());
		this.setTitle("Communication Monitor");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BoxLayout(getJContentPane(),
					BoxLayout.Y_AXIS));
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(getOptionsPanel(), null);
		}
		return jContentPane;
	}

	/* (non-Javadoc)
	 * @see edu.bonn.xulu.gui.XuluInternalFrame#refresh()
	 */
	@Override
	public void refresh() {
		// TODO Auto-generated method stub

	}

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.addTab("Time Events", null, getJScrollPane(), null);
			jTabbedPane
					.addTab("Transfer Events", null, getJScrollPane1(), null);
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes clearButton	
	 * 	
	 * @return java.awt.Button	
	 */
	private Button getClearButton() {
		if (clearButton == null) {
			clearButton = new Button();
			clearButton.setLabel("Clear all");
			clearButton.setMinimumSize(new Dimension(100, 20));
			clearButton.setName("clearButton");
			clearButton.addActionListener(engine);
		}
		return clearButton;
	}

	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getTransferEventTable());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes transferEventTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getTransferEventTable() {
		if (transferEventTable == null) {
			transferEventTable = new JTable();
			transferEventTable.setDoubleBuffered(true);
		}
		return transferEventTable;
	}

	/**
	 * This method initializes jTextPane	
	 * 	
	 * @return javax.swing.JTextPane	
	 */
	private JTextPane getJTextPane() {
		if (jTextPane == null) {
			jTextPane = new JTextPane();
			jTextPane
					.setText("Hint: Hold CTRL while clicking on a table header for secondary sorting");
			jTextPane.setMaximumSize(new Dimension(100, 50));
		}
		return jTextPane;
	}

} //  @jve:decl-index=0:visual-constraint="10,10"
