package appl.parallel.starter.client;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import org.apache.log4j.BasicConfigurator;

import appl.parallel.starter.Starter;

/**
 * This is a GUI for controlling the {@link Starter Starters} in the network.
 * It has options to start/stop and restart selected servers.
 * @author Dominik Appl
 *
 */
public class StarterClientGUI extends JFrame {
	/**
	 * Creates a new GUI
	 */
	public StarterClientGUI() {
		super("Server starter");
		this.getContentPane().add(new XuluStarterController().getPanel());
		this.setSize(300, 400);
		this.addWindowListener(new ExitListener());
	}

	/**
	 * @param args no arguments interpreted
	 */
	public static void main(String[] args) {
		BasicConfigurator.configure();
		StarterClientGUI clientGUI = new StarterClientGUI();
		clientGUI.setVisible(true);
	}

	/**
	 * Shuts down the application on exit
	 * 
	 * @author Dominik Appl
	 */
	public class ExitListener extends WindowAdapter {
		public void windowClosing(WindowEvent event) {
			System.exit(0);
		}
	}
}
