package appl.parallel.starter.client;

import java.rmi.RemoteException;

import appl.parallel.starter.Starter;

/**
 * Just a small container class used e.g. in the
 * {@link XuluStarterControllerFrame} for display
 * 
 * @author Dominik Appl
 */
public class StarterContainer {
	private final Starter starter;

	private boolean isRunning;

	private final String hostInfo;

	/**
	 * A Container for use in SwingComponents. The status ({@link #isServerRunning()}
	 * is only the status at the creation of the object!
	 * 
	 * @param starter
	 *            The encapsulated Starter
	 * @param hostInfo
	 */
	public StarterContainer(Starter starter, String hostInfo) {
		this.starter = starter;
		this.hostInfo = hostInfo;
		try {
			isRunning = starter.isRunning();
		} catch (RemoteException e) {
			isRunning = false;
		}
	}

	public boolean isServerRunning() {
		return isRunning;
	}

	public Starter getStarter() {
		return starter;
	}

	public String toString() {
		return hostInfo;
	}
}
