package appl.parallel.starter.server;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.GridBagLayout;
import javax.swing.JTextArea;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import javax.swing.JScrollPane;
import javax.swing.BoxLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;

import schmitzm.swing.event.PopupMenuListener;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.CardLayout;

/**
 * This is the GUI for the {@link XuluServerStarter}
 * 
 * @author Dominik Appl
 */
public class XuluStarterServerGUI extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel controlPanel = null;

	 JTextArea consoleArea = null;

	JButton button_start = null;

	 JButton button_stop = null;

	 JButton button_exit = null;

	private JScrollPane jScrollPane = null;

	private JPopupMenu jPopupMenu = null;  //  @jve:decl-index=0:visual-constraint="615,231"

	private JMenuItem clearText = null;

	private JPanel jPanel = null;

	private JButton button_clear = null;

	/**
	 * This is the default constructor
	 */
	public XuluStarterServerGUI() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(450, 316);
		this.setContentPane(getJContentPane());
		this.setTitle("Xulu Server Starter");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.fill = GridBagConstraints.HORIZONTAL;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.ipadx = 140;
			gridBagConstraints6.gridy = 2;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.BOTH;
			gridBagConstraints5.gridy = 1;
			gridBagConstraints5.ipadx = 0;
			gridBagConstraints5.ipady = 0;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.weighty = 1.0;
			gridBagConstraints5.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints5.gridx = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.ipadx = 0;
			gridBagConstraints3.ipady = 0;
			gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridy = 5;
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(getJScrollPane(), gridBagConstraints5);
			jContentPane.add(getControlPanel(), gridBagConstraints6);
			jContentPane.add(getJPanel(), gridBagConstraints8);
		}
		return jContentPane;
	}

	/**
	 * This method initializes controlPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getControlPanel() {
		if (controlPanel == null) {
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.fill = GridBagConstraints.BOTH;
			gridBagConstraints11.gridy = 3;
			gridBagConstraints11.weightx = 1.0;
			gridBagConstraints11.weighty = 1.0;
			gridBagConstraints11.gridx = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 3;
			gridBagConstraints2.anchor = GridBagConstraints.EAST;
			gridBagConstraints2.gridy = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 2;
			gridBagConstraints1.anchor = GridBagConstraints.WEST;
			gridBagConstraints1.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.anchor = GridBagConstraints.WEST;
			gridBagConstraints.gridy = 1;
			controlPanel = new JPanel();
			controlPanel.setLayout(new GridBagLayout());
			controlPanel.add(getButton_start(), gridBagConstraints);
			controlPanel.add(getButton_stop(), gridBagConstraints1);
			controlPanel.add(getButton_exit(), gridBagConstraints2);
		}
		return controlPanel;
	}

	/**
	 * This method initializes consoleArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getConsoleArea() {
		if (consoleArea == null) {
			consoleArea = new JTextArea();
			consoleArea.setToolTipText("");
			consoleArea.setWrapStyleWord(false);
			consoleArea.setLineWrap(true);
			consoleArea.addMouseListener(new PopupMenuListener(this.getJPopupMenu()));
		}
		return consoleArea;
	}

	/**
	 * This method initializes button_start	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton_start() {
		if (button_start == null) {
			button_start = new JButton();
			button_start.setText("Start Server");
		}
		return button_start;
	}

	/**
	 * This method initializes button_stop	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton_stop() {
		if (button_stop == null) {
			button_stop = new JButton();
			button_stop.setText("Stop Server");
		}
		return button_stop;
	}

	/**
	 * This method initializes button_exit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton_exit() {
		if (button_exit == null) {
			button_exit = new JButton();
			button_exit.setText("Exit Starter");
		}
		return button_exit;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setDoubleBuffered(false);
			jScrollPane.setViewportView(getConsoleArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jPopupMenu	
	 * 	
	 * @return javax.swing.JPopupMenu	
	 */
	private JPopupMenu getJPopupMenu() {
		if (jPopupMenu == null) {
			jPopupMenu = new JPopupMenu();
			jPopupMenu.add(getClearText());

			
		}
		return jPopupMenu;
	}

	/**
	 * This method initializes clearText	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getClearText() {
		if (clearText == null) {
			clearText = new JMenuItem();
			clearText.setText("clear");
			clearText.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getConsoleArea().setText("");
				}
			});
		}
		return clearText;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setHgap(0);
			flowLayout.setVgap(0);
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 0;
			gridBagConstraints9.anchor = GridBagConstraints.EAST;
			gridBagConstraints9.gridy = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridy = -1;
			gridBagConstraints4.anchor = GridBagConstraints.WEST;
			gridBagConstraints4.gridx = -1;
			jPanel = new JPanel();
			jPanel.setLayout(flowLayout);
			jPanel.add(getButton_clear(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes button_clear	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton_clear() {
		if (button_clear == null) {
			button_clear = new JButton();
			button_clear.setText("Clear Console");
			button_clear.setPreferredSize(new Dimension(130, 15));
			button_clear.setName("jButton");
			button_clear.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getConsoleArea().setText("");
				}
			});
		}
		return button_clear;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
