/** GnuR Plugin - A XULU-plugin for applying R-powered statistics on objects in the XULU-datapool.
    Copyright (C) 2007  Stefan A. Krüger

    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

    Diese Bibliothek ist freie Software; Sie dürfen sie unter den Bedingungen der GNU Lesser General Public License, wie von der Free Software Foundation veröffentlicht, weiterverteilen und/oder modifizieren; entweder gemäß Version 2.1 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
    Diese Bibliothek wird in der Hoffnung weiterverbreitet, daß sie nützlich sein wird, jedoch OHNE IRGENDEINE GARANTIE, auch ohne die implizierte Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Mehr Details finden Sie in der GNU Lesser General Public License.
    Sie sollten eine Kopie der GNU Lesser General Public License zusammen mit dieser Bibliothek erhalten haben; falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 **/  
package de.skrueger.xulu.plugin.gnur;

import schmitzm.data.property.Property;
import schmitzm.data.property.PropertyException;

/**
 * This Exception is thrown, when the object from the datapool is not convertable to an R object. This can be
 * due to the structure of the data, or due to the GnuR plugins capabilities.  
 *
 * @author Stefan A. Krüger
 */
public class PropertytypeNotConvertableToRVar extends PropertyException{

	public PropertytypeNotConvertableToRVar(Property prop) {
		super(prop, "The Propertytype can not be converted to an R variable.");
	}

	public PropertytypeNotConvertableToRVar(Property prop, String msg) {
	    super(prop, msg);
	}

}
