/** XULU - This file is part of the eXtendable Unified Land Use Modelling Platform (XULU)

    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

    Diese Bibliothek ist freie Software; Sie dürfen sie unter den Bedingungen der GNU Lesser General Public License, wie von der Free Software Foundation veröffentlicht, weiterverteilen und/oder modifizieren; entweder gemäß Version 2.1 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
    Diese Bibliothek wird in der Hoffnung weiterverbreitet, daß sie nützlich sein wird, jedoch OHNE IRGENDEINE GARANTIE, auch ohne die implizierte Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Mehr Details finden Sie in der GNU Lesser General Public License.
    Sie sollten eine Kopie der GNU Lesser General Public License zusammen mit dieser Bibliothek erhalten haben; falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 **/

package edu.bonn.xulu.plugin.appl;

import schmitzm.lang.LangUtil;

import edu.bonn.xulu.gui.XuluInternalFrame;

/**
 * Dieses Plugin integriert die {@link edu.bonn.xulu.plugin.appl.RasterCalculatorGUI}
 * in das Xulu-Menue "Erweitert".
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of Bonn/Germany)
 * @version 1.0
 */
public class RasterCalculatorPlugin extends AbstractMenuPlugin {
  private static final int MENU_ID = 4; // Erweitert
  private static final String CALCULATOR_CLASSNAME = "edu.bonn.xulu.plugin.appl.RasterCalculatorGUI";

  /**
   * Erzeugt eine neue Plugin-Instanz.
   */
  public RasterCalculatorPlugin() {
    super(MENU_ID,"Raster-Calculator");
  }

  /**
   * Erzeugt eine Instanz der Plugin-Applikation {@link RasterCalculatorGUI}.
   */
  protected XuluInternalFrame createPluginApplication() throws Exception {
//    return (XuluInternalFrame)LangUtil.loadPreferredObject(CALCULATOR_CLASSNAME,appl);
    return new RasterCalculatorGUI(appl);
  }
}
